
#include <Keypad.h>

const byte ROWS = 4; // Nombre de lignes du clavier
const byte COLS = 4; // Nombre de colonnes du clavier

char keys[ROWS][COLS] = {
  {'1','2','3','A'},
  {'4','5','6','B'},
  {'7','8','9','C'},
  {'*','0','#','D'}
};

byte rowPins[ROWS] = {9, 8, 7, 6}; // Broches connectées aux lignes du clavier
byte colPins[COLS] = {5, 4, 3, 2}; // Broches connectées aux colonnes du clavier

Keypad keypad = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );

const int led1Pin = 12; // Broche pour la première LED
const int led2Pin = 11; // Broche pour la deuxième LED
const int led4Pin = 13; // Broche pour la quatrième LED
const int relayPin =10; // Broche pour le relais contrôlant l'électroaimant

String enteredCode = ""; // Variable pour stocker le code entré

void setup() {
  pinMode(led1Pin, OUTPUT);
  pinMode(led2Pin, OUTPUT);
  pinMode(led4Pin, OUTPUT);
  pinMode(relayPin, OUTPUT);
}

void loop() {
  char key = keypad.getKey();
  
  if (key != NO_KEY) {
    if (key == '#') { // Si le bouton # est pressé, vérifier le code
      if (enteredCode.equals("1B7")) { // Si le code est correct
        digitalWrite(led1Pin, HIGH); // Allumer la première LED
        digitalWrite(led2Pin, HIGH); // Allumer la deuxième LED
        digitalWrite(led4Pin, LOW); // Éteindre la quatrième LED
        digitalWrite(relayPin, HIGH); // Activer l'électroaimant
        delay(5000); // Maintenir l'électroaimant activé pendant 5 secondes
        digitalWrite(relayPin, LOW); // Désactiver l'électroaimant après 5 secondes
      } else {
        digitalWrite(led1Pin, LOW); // Éteindre la première LED
        digitalWrite(led2Pin, LOW); // Éteindre la deuxième LED
        digitalWrite(led4Pin, HIGH); // Allumer la quatrième LED
        digitalWrite(relayPin, LOW); // S'assurer que l'électroaimant est éteint
      }
      enteredCode = ""; // Réinitialiser le code après vérification
    } else {
      enteredCode += key; // Ajouter le caractère à la variable du code
    }
  }
}
